#ifndef _REX_SMA_02_H_
#define _REX_SMA_02_H_
/*
 *	LPT routines for REX-SMA02 programmed by Hanimar.
 *	'REX-SMA02 Parallel SmartMedia Reader/Writer' is a trademark of 
 *	RATOC Systems,Inc.
 *	Greet to TSG of Non-Standard.
 */
/*
 *	FƂ肠wb_Ă܂B
 */
/* sys/types.h n */
typedef unsigned long ULONG;
typedef unsigned int UINT;
typedef unsigned char UCHAR;
/* LPT n */

#define LPTDATA(base)	(base)
#define LPTSTAT(base)	((base) + 1)
#define LPTCTRL(base)	((base) + 2)

#define IN(port)	inp(port)
#define OUT(port, c)	outp(port, c)

#define STS_ERR		0x08
#define STS_SEL		0x10
#define STS_PE		0x20
#define STS_ACK		0x40
#define STS_BUSY	0x80
/* Control */
#define CTL_STB		0x01
#define CTL_ALF		0x02
#define CTL_INIT	0x04
#define CTL_SELIN	0x08
#define CTL_DIR		0x20

#define LPT_NORMAL		0
#define LPT_BIDIRECTIONAL	1

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	lptNo: 1 w肵ĂB
 *	returns: I/O base address
 *	description:
 *	DOS ܂B
 */
int LptGetPortAddr(int lptNo);
/*
 *	(STATUS & mask) == data ɂȂ܂ő҂B
 *	ő timeout(P msec) ̊ԑ҂BB
 */
int LptWaitStatus(int base, int mask, int data, int timeout);
/*
 *	msec ҂B
 */
long WaitMSec(long msec);
/*
 *	bidirectional T|[gĂ邩H
 *	1: Ă
 */
int LptIsBidirectionalSupported(int base);


/*
 *	ȉ SMA02 ŗL
 */
int Sma02Open(int base, int mode);
int Sma02Close(int base);

/*
 *	which ͓ǂݍޑΏۂŁA
 *	 1: Xe[^XWX^ 0: f[^WX^B
 */
void Sma02NibbleRead(int base, int which, char *buffer, int len);
void Sma02ByteRead(int base, int which, char *buffer, int len);
void Sma02Read(int base, int which, char *buffer, int len);
UCHAR Sma02Read1Byte(int base, int which);
//#define Sma02ReadStatus(base) Sma02Read(base, 1)
//#define Sma02ReadData(base) Sma02Read(base, 0)

void Sma02ByteWrite(int base, int which, const char *data, int len);
void Sma02Write1Byte(int base, int which, const char data);
//#define Sma02WriteStatus(base, data) Sma02Write1Byte(base, 1, data)
//#define Sma02WriteData(base, data) Sma02Write1Byte(base, 0, data)

void Sma02WriteCommand(int base, UCHAR cmd);
void Sma02Reset(int base);
void Sma02ReadID(int base, char *dest);
UCHAR Sma02ReadStatus(int base);
int Sma02EraseAll(int base, int nBlock); /* nBlock=1024 */
int Sma02EraseBlock(int base, int blockNo);
void Sma02ReadPage(int base, UCHAR *buffer, int address, int nPage,
	int (*procedure)(UCHAR *buffer, void *userData), void *userData);
int Sma02ReadSector(int base, UCHAR *buffer, int address);

/* s */
void Sma02ReadPage2(int base, UCHAR *buffer, int address, int nPage,
	int (*procedure)(UCHAR *buffer, void *userData), void *userData);
int Sma02WritePage(int base, const UCHAR *data, int address);

/*
 *	bidirectional pAƂ肠B8MB Ƃ񂾂ołȂƂ˂B
 */

#ifdef __cplusplus
}
#endif

#endif /* _REX_SMA_02_H_ */

#if 0
/*** pB ***/

From "PC Parallel Port Mini-FAQ"
By Kris Heidenstrom (kheidenstrom@actrix.gen.nz), revision 2, 941019
---------------------------------------------------------------------
3.1  DATA REGISTER

The data register is at IOBase+0.  It may be read and written (using
the IN and OUT instructions, or inportb() and outportb() or inp()
and outp()).  Writing a byte to this register causes the byte value
to appear on pins 2 through 9 of the D-sub connector (unless the port
is bidirectional and is set to input mode).  The value will remain
latched until you write another value to the data register.
Reading this register yields the state of those pins.

.7 6 5 4 3 2 1 0
.* . . . . . . .  D7 (pin 9), 1=High, 0=Low
.. * . . . . . .  D6 (pin 8), 1=High, 0=Low
.. . * . . . . .  D5 (pin 7), 1=High, 0=Low
.. . . * . . . .  D4 (pin 6), 1=High, 0=Low
.. . . . * . . .  D3 (pin 5), 1=High, 0=Low
.. . . . . * . .  D2 (pin 4), 1=High, 0=Low
.. . . . . . * .  D1 (pin 3), 1=High, 0=Low
.. . . . . . . *  D0 (pin 2), 1=High, 0=Low

3.2  STATUS REGISTER

The status register is at IOBase+1.  It is read-only (writes will be
ignored).  Reading the port yields the state of the five status input
pins on the parallel port connector at the time of the read access:

.7 6 5 4 3 2 1 0
.* . . . . . . .  Busy . . (pin 11), high=0, low=1 (inverted)
.. * . . . . . .  Ack  . . (pin 10), high=1, low=0 (true)
.. . * . . . . .  No paper (pin 12), high=1, low=0 (true)
.. . . * . . . .  Selected (pin 13), high=1, low=0 (true)
.. . . . * . . .  Error. . (pin 15), high=1, low=0 (true)
.. . . . . * * *  Undefined

3.3  CONTROL REGISTER

The control register is at IOBase+2.  It is read/write:

.7 6 5 4 3 2 1 0
.* * . . . . . .  Unused (undefined on read, ignored on write)
.. . * . . . . .  Bidirectional control, see below
.. . . * . . . .  Interrupt control, 1=enable, 0=disable
.. . . . * . . .  Select . . (pin 17), 1=low, 0=high (inverted)
.. . . . . * . .  Initialize (pin 16), 1=high, 0=low (true)
.. . . . . . * .  Auto Feed  (pin 14), 1=low, 0=high (inverted)
.. . . . . . . *  Strobe . . (pin 1),  1=low, 0=high (inverted)

#endif
