/*
 *	q`vf[^obNAbv
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include "sma02.h"
#include "ps2mc.h"

static int GetFormatVersion(int base);
static int doIt(int base, FILE *fpout);

static const char *FileName = NULL;
//	int mode = ;
static int Mode = LPT_NORMAL;

void Usage(const char *me)
{
	const char *ptr;
	
	ptr = strrchr(me, '\\');
	if (ptr == NULL) ptr = strrchr(me, ':');
	if (ptr == NULL) ptr = me;
	else ptr ++;
	
	fprintf(stderr, "%s Build:%s. Programmed by Hanimar.\n", ptr, __DATE__);
	fprintf(stderr, "Usage: %s [/b] <filename>\n", ptr);
	fputs("/b : Bidirectional mode.\n", stderr);
	exit(EXIT_FAILURE);
}
void argchk(int argc, char **argv)
{
	int i, j;
	int fileSpecified = 0;
	
	for (i = 1 ; i < argc ; i ++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			for (j = 1 ; argv[i][j] != '\0' ; j ++) {
				switch (argv[i][j]) {
				case 'b':
				case 'B':
					Mode = LPT_BIDIRECTIONAL;
					break;
				default:
					Usage(argv[0]);
				}
			}
			continue;
		}
		if (fileSpecified) Usage(argv[0]);
		FileName = argv[i];
		fileSpecified ++;
	}
	if (FileName == NULL) Usage(argv[0]);
	
	return;
}

int main(int argc, char **argv)
{
	int base;
	UCHAR status;
	int rc;
	int retry;
	FILE *fpout = NULL;
	
	argchk(argc, argv);
	
	if (access(FileName, 004) == 0) {
		int c;
		fprintf(stderr, "File %s exists. Back up anyway?[y/n]", FileName);
		fflush(stderr);
		for (;;) {
			while (!kbhit());
			c = getch();
			if (c == 'y' || c == 'Y') break;
			if (c == 'n' || c == 'N') return EXIT_FAILURE;
		}
		fputc('\n', stderr);
	}
	fpout = fopen(FileName, "wb");
	if (fpout == NULL) {
		fprintf(stderr, "Can not open file \"%s\".\n", FileName);
		return EXIT_FAILURE;
	}
	
	base = LptGetPortAddr(1);	/* LPT1 = 378H ̂͂ */
	rc = Sma02Open(base, Mode);
	if (rc < 0) {
		Sma02Close(base);
		WaitMSec(200L);
		rc = Sma02Open(base, Mode);
		if (rc < 0) {
			fputs("Can not connect to SmartMedia via LPT1.\n", stderr);
			Sma02Close(base);
			fclose(fpout);
			remove(FileName);
			return EXIT_FAILURE;
		}
	}
	/* 200 ~bقǑ҂܂BӖ͂ȂłǁB */
	WaitMSec(200L);
	Sma02Write1Byte(base, 1, 0x1c);	/* VCC ON */
	WaitMSec(20L);

	/* fBAĂ邩ׂ܂ */
	for (retry = 100 ; retry ; retry --) {
		status = Sma02Read1Byte(base, 1);
		if ((status & 0x80) == 0) break;
		Sma02Reset(base);
	}
	if ((status & 0x04) == 0) {
		fprintf(stderr, "SmartMedia is not set.(%02Xh)\n", status);
		Sma02Write1Byte(base, 1, 0x18);	/* VCC OFF */
		Sma02Close(base);
		fclose(fpout);
		remove(FileName);
		return EXIT_FAILURE;
	}
	
	rc = doIt(base, fpout);
	fclose(fpout);
	if (rc != 0) remove(FileName);
	
	Sma02Close(base);
	return rc == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
}

static int Err;
int Counter;

int writeIt(char *buffer, void *userData)
{
	FILE *fp = (FILE *)userData;
	
	if (!(Counter & 0x0f))
		printf("Block#%04d/1024\r", 1 + (Counter >> 4));
	
	if (fwrite(buffer, 1, 528, fp) != 528) {
		puts("\nWrite failed.");
		Err --;
		return -1;
	}
	Counter ++;
	return 0;
}

static int doIt(int base, FILE *fpout)
{
	int rc;
	UCHAR buffer[528];
	
	Err = 0; Counter = 0;
	Sma02ReadPage(base, buffer, 0, 16 * 1024, writeIt, (void *)fpout);

	return Err;
}

